% update W based on either gradient descent, or mini-batch gradient descent
% obj: L = || X - G SIGMA(WY) ||_{F}
% partial derivative: ??
% X: sparse code, each column is a sparse code
% Y: features, each column is a feature
% W: regressor
% taud: learning rate
function W = ProjW(W,X,Y,tauw,G)

if size(Y,2) < 10000
    dW = LogisticReg_v2(X,Y,W,G);
    W = W - tauw*dW;
else
    S = size(Y,2);
    r = randperm(S);
    for i = 1:floor(S/1000)
        Y1 = Y(:,r(1+(i-1)*1000:i*1000));
        X1 = X(:,r(1+(i-1)*1000:i*1000));
        dW = LogisticReg_v2(X1,Y1,W,G);
        W = W - tauw*dW;
    end
end
